//Sequential Doing
//created by Alvar Gámez Zerban
enchant();


window.onload = function(){
	
	/*
	* Variables
	*/	
	var fps = 30;
	var gamewidth = 320;
	var gameheight = 320;
	var GUIWidth = 160;
	var spriteSize = 32;
	var stand = false;
	var framesWaited = 0;
	var moverArray = [];
	var sequence = [];
	var inputSequence = [];
	var up = 0;
	var left = 1;
	var down = 2;
	var right = 3;	
	var sequenceIndex = 0;
	var sequenceLength = 3;	
	var movementSpeed = 1;
	var groupSize = 3;	

	var anyButtonDown = false;
	var upButton = false;
	var leftButton = false;
	var downButton = false;
	var rightButton = false;
	var bButton = false;

	var sequenceWrong = false;

	var actualSequenceID = 0;
	var randomSequenceID = 1;
	var partialRandomSequenceID = 2;
	var movementArray = [];
	
	var partialSequence = [];
	var partialSequenceIndex = 0;
	var partialRandomSequenceIndex = 0;
	var randomPartHandled = false;
	
	var difficultLevel = 0;
	var lives = 3;
	var running = true;
	//GUI
	var GUISequenceElements = [];
	var GUILives = [];
	var GUIDifficultyArray = [];
	var GUIDifficultyLabel;
	/*
	* Variables end
	*/
	
	var game = new Core(gamewidth+GUIWidth, gameheight);
	game.fps = fps;
	game.preload("c.png","map1.png","end.png","icon0.png");
	
	
	//Key binds	
	//left arrow 	37
	//up arrow 	38
	//right arrow 	39
	//down arrow 	40 
	game.keybind(37,'left');
	game.keybind(38,'up');
	game.keybind(39,'right');
	game.keybind(40,'down');
	
	game.keybind(32,'b');


	/*
	* Mover class and methods
	*/
	var Mover = enchant.Class.create(enchant.Sprite, {
		initialize: function(x, y) {
			enchant.Sprite.call(this, spriteSize, spriteSize);
			this.x = x;
			this.y = y;
			this.image = game.assets['c.png'];
			this.frame = 0;
			game.rootScene.addChild(this);
		}
	});

	function createMover(startFrame,endFrame,startX,startY)
	{
		var mover = new Mover(startX,startY);
		mover.frame = startFrame;
		mover.startFrame = startFrame;
		mover.endFrame = endFrame;
		resetSpeed(mover);
		return mover;	
	}

	function setRandomSpeed(mover)
	{	
		if(rand(0,1) == 0)
		{	
			mover.speedX = [-movementSpeed,movementSpeed][rand(0,1)];		
			mover.speedY = 0;
		}
		else
		{			
			mover.speedX = 0;
			mover.speedY = [-movementSpeed,movementSpeed][rand(0,1)];
		}		
	}
	
	function resetSpeed(mover)
	{
		mover.speedX = 0;
		mover.speedY = 0;
	}		

	function move(mover)
	{
		if(mover.speedX > 0)
		{
			mover.scaleX = 1;
		}else if(mover.speedX < 0)
		{
			mover.scaleX = -1;
		}
		
		if(-spriteSize/2 < mover.x && mover.x < gamewidth - spriteSize)
		{
			mover.x += mover.speedX;
			
		}else if (mover.x >= gamewidth-spriteSize)
		{
			mover.x = -spriteSize/2 + 1;
		}
		else
		{
			mover.x = gamewidth-spriteSize-1;
		}
		if(-spriteSize/2 < mover.y && mover.y < gameheight -spriteSize/2)
		{
			mover.y += mover.speedY;
		}else if( mover.y >= gameheight - spriteSize/2)
		{
			mover.y = -spriteSize/2 + 1;
		}else
		{
			mover.y = gameheight-1-spriteSize/2;
		}
		mover.frame = [0,1,0,2][Math.floor(mover.age/5) % 4] + mover.startFrame;
		
	}
	
	function setSpeed(mover, speedX, speedY)
	{
		mover.speedX = speedX;
		mover.speedY = speedY;
	}

	function moveAll()
	{
		for(i = 0; i < moverArray.length; ++i)
		for(j = 0; j < moverArray[i].length; ++j)			
			move(moverArray[i][j]);
	}
	
	/*
	* Mover end
	*/
	
	/*
	* Group methods
	*/

	function createMoverGroup(firstFrame, lastFrame, amountOfMover)
	{
		moverGroup = [];
		for(i = 0; i < amountOfMover; ++i)
		{
			var randomX = rand((spriteSize/2) +1, gamewidth-(spriteSize/2)-1);
			var randomY = rand((spriteSize/2) +1, gamewidth-(spriteSize/2)-1);
			moverGroup[i] = createMover(firstFrame,lastFrame,randomX,randomY);	
		}
		return moverGroup;
	}

	function increaseGroupSize()
	{
		for(m = 0; m < moverArray.length; ++m)
		{
			var group = createMoverGroup(moverArray[m][0].startFrame,moverArray[m][0].endFrame,groupSize);
			moverArray[m] = moverArray[m].concat(group);

		}

	}

	function addGroup(group)
	{
		moverArray[moverArray.length] = group;

	}	

	function setRandomMovement(group)
	{
		for(i = 0; i < group.length; ++i)
		{
			setRandomSpeed(group[i]);			
		}

		if(group[0].speedX == group[1].speedX && group[0].speedY == group[1].speedY)
		{
			group[0].speedX = -group[1].speedX;
			if(group[0].speedX == 0)
				group[0].speedY = -group[1].speedY;
			else
				group[0].speedY = 0;
		}
		
		
	}

	function getDirectionFromSequence(index,sequenceArray)
	{
		var speedX = 0;
		var speedY = 0;
		var speed = [];
		var direction = sequenceArray[index]
		switch(direction)
		{
			case up:
				speedY = -movementSpeed;
				speedX = 0;
				break;
			case left:
				speedY = 0;
				speedX = -movementSpeed;
				break;
			case down:
				speedY = movementSpeed;
				speedX = 0;
				break;
			case right:
				speedY = 0;
				speedX = movementSpeed;
				break;
		}
		speed[0] = speedX;
		speed[1] = speedY;
		return speed;
	}
	
	function setMovementBySequence(group)
	{	
		var speed = getDirectionFromSequence(sequenceIndex,sequence);
		
		for(j = 0; j < group.length; ++j)
		{
			setSpeed(group[j],speed[0],speed[1]);
		}			
		
	}

	function setPartialSequenceMovement(group)
	{		
		
		if(partialSequenceIndex == partialRandomSequenceIndex && randomPartHandled)
		{
			randomPartHandled = false;
		}
		if(partialSequenceIndex == partialRandomSequenceIndex && !randomPartHandled)
		{
			randomPartHandled = true;
			setRandomMovement(group);
			return;
		}
		var speed = getDirectionFromSequence(partialSequenceIndex,partialSequence);		
		for(j = 0; j < group.length; ++j)
		{
			setSpeed(group[j],speed[0],speed[1]);
		}
		++partialSequenceIndex;
		partialSequenceIndex = partialSequenceIndex % (sequenceLength-1);	
	}
	
	function handleMovement()
	{

		if(stand)
		{
			if(framesWaited > fps/2)
			{
				stand = false;
				framesWaited = 0;
				++sequenceIndex;
				sequenceIndex = sequenceIndex % sequenceLength;
				
			}
			++framesWaited;
		}else{				
			if(game.frame % fps*3 == 0)
			{	
				handleMovementPattern();
				stand = true;			
			}					
			moveAll();
			
		}
	}
	
	function shuffleMovementPattern()
	{
		var seqIndex = rand(0,moverArray.length-1);
		var partSeqIndex = rand(0,moverArray.length-1);
		while(partSeqIndex == seqIndex)
		{
			partSeqIndex = rand(0,moverArray.length-1);
		}
		movementArray = [];
		for(i = 0; i < moverArray.length; ++i)
		{
			if(i == seqIndex)
			{
				movementArray[i] = actualSequenceID;
			}else if(i == partSeqIndex)
			{
				movementArray[i] = partialRandomSequenceID;
			}
			else
			{
				movementArray[i] = randomSequenceID;
			}
		}

	}

	function handleMovementPattern()
	{
		for(n = 0; n < moverArray.length; ++n)
		{
			group = moverArray[n];
			switch(movementArray[n])
			{
				case actualSequenceID:
					setMovementBySequence(group);
					break;
				case randomSequenceID:
					setRandomMovement(group);
					break;
				case partialRandomSequenceID:
					setPartialSequenceMovement(group);
					break;
				default: setRandomMovement(group);
			}		
		}
	}

	/*
	* Group end
	*/
	
	/*
	* Sequences
	*/

	function createNewSequence(length)
	{
		var newSequence = [];
		var first = rand(up,right);
		var last = rand(up,right);
		newSequence[0] = first;
		for(i = 1; i < length-1; ++i)
		{
			newSequence[i] = rand(up,right);
		}
		while(last == first)
		{
			last = rand(up,right);
		}
		newSequence[length-1] = last;
		return newSequence;
	}
	
	function createSequence(length)
	{
		sequence = createNewSequence(length);
	}

	function createPartialSequence(length)
	{	
		partialRandomSequenceIndex = rand(0,length-1);		
		partialSequence = createNewSequence(length-1);
	}

	function handleInput()
	{
		game.rootScene.on('upbuttondown', function(){
			if(!anyButtonDown)
			{
				anyButtonDown = true;
				upButton = true;
				inputSequence[inputSequence.length] = up;
			}
		});
		game.rootScene.on('upbuttonup', function(){
			if(anyButtonDown && upButton)
			{
				anyButtonDown = false;
				upButton = false;
			}
		});
		game.rootScene.on('downbuttondown', function(){
			if(!anyButtonDown)
			{
				anyButtonDown = true;
				downButton = true;
				inputSequence[inputSequence.length] = down;
			}
		});
		game.rootScene.on('downbuttonup', function(){
			if(anyButtonDown && downButton)
			{
				anyButtonDown = false;
				downButton = false;
			}
		});
		game.rootScene.on('rightbuttondown', function(){
			if(!anyButtonDown)
			{
				anyButtonDown = true;
				rightButton = true;
				inputSequence[inputSequence.length] = right;
			}
		});
		game.rootScene.on('rightbuttonup', function(){
			if(anyButtonDown && rightButton)
			{
				anyButtonDown = false;
				rightButton = false;
			}
		});
		game.rootScene.on('leftbuttondown', function(){
			if(!anyButtonDown)
			{
				anyButtonDown = true;
				leftButton = true;
				inputSequence[inputSequence.length] = left;
			}
		});
		game.rootScene.on('leftbuttonup', function(){
			if(anyButtonDown && leftButton)
			{
				anyButtonDown = false;
				leftButton = false;
			}
		});
		//doesnt work...
		game.rootScene.on('bbuttondown',function(){
			if(!anyButtonDown && !bButton)			
			{	
				sequenceInput = [];
				anyButtonDown = true;
				bButton = true;
			}

		});
		game.rootScene.on('bbuttonup',function(){
			if(anyButtonDown && bButton)
			{
				anyButtonDown = false;
				bButton = false;
			}

		});
	}

	function checkSequences()
	{
		if(inputSequence.length < sequence.length)
		{
			return false;
		}
		//this can not occour
		if(inputSequence.length > sequence.length)
		{
			sequenceWrong = true;
			//alert("sequence is too long!");
			return false;
		}
		var j = 0;
		for(i = 0; i < sequence.length; ++i)
		{
			var start = i;
			while(sequence[i] != inputSequence[j])
			{
				++j;
				j = j % inputSequence.length;
				if(j == start)
				{
					sequenceWrong = true;
					//alert("sequence is wrong!");
					return false;
				}
			}
			k = i;
			l = j;
			while(sequence[k] == inputSequence[l])
			{
				++k;
				++l;
				l = l % inputSequence.length;
				if(k == sequence.length)
					return true;
			}			
		}
		sequenceWrong = true;
		//alert("sequence is wrong!");
		return false;
	}

	function handleSequences()
	{
		var fits = checkSequences();
		if(fits)
		{
			//alert("sequence is right");
			sequenceWrong = false;
			inputSequence = [];
			
			handleDifficulty();
			createSequence(sequenceLength);
			shuffleMovementPattern();

		}else{
			if(sequenceWrong)
			{
				sequenceWrong = false;
				inputSequence = [];
				--lives;
				removeHeart();
				if(lives == 0)
				{
					//display Gameover and stop the game;
					//running = false;
					displayGameOver();
					game.rootScene.clearEventListener();
				}
				//createSequence(sequenceLength);
			}
		}
	}

	function handleDifficulty()
	{
		++difficultLevel;
		correctLabel();
		if(difficultLevel % 2 == 0)
		{
			//increase difficulty
			++sequenceLength;
			
		}
		if(difficultLevel % 3 == 0)
		{
			increaseGroupSize();
		}
		
	}

	/*
	* Sequences end
	*/

	/*
	* Background
	*/
	function setupBackGround()
	{
		var grassTile = 4;
		var singleDirtBig = 16*4+5;
		var singleDirtSmall = 16*4+3;
		var dirtleftUC = 16*5+3;
		var dirtmiddleU = 16*5+4;
		var dirtrightUC = 16*5+5;
		var dirtleft = 16*6+3;
		var dirtmiddle = 16*6+4;
		var dirtright = 16*6+5;
		var dirtleftLC = 16*7+3;
		var dirtmiddleL = 16*7+4;
		var dirtrightLC = 16*7+5;
		
		var woodsLUC = 16*9+3;
		var woodsMU = 16*9+4;
		var woodsRUC = 16*9+5;
		var woodsL = 16*10+3;
		var woodsM = 16*10+4;
		var woodsR = 16*10+5;
		var woodsLLC = 16*11+3;
		var woodsML = 16*11+4;
		var woodsRLC = 16*11+5;
	
		var map = new Map(16, 16);
		map.image = game.assets['map1.png'];
		map.loadData(
		    [
		        [4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, woodsLLC, woodsM, woodsM, woodsM, woodsM, woodsM, woodsM],
		        [4, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, woodsLLC, woodsM, woodsM, woodsM, woodsM],
		        [4, 5, 4, 5, 4, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, woodsLLC, woodsM, woodsM, woodsM],
		        [4, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, woodsLLC, woodsM, woodsM, woodsM],
			[4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, woodsLLC, woodsM, woodsM],
			[4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, woodsLLC, woodsML],
			[4, 4, 4, 4, singleDirtSmall, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
			[4, 5, dirtleftUC, dirtmiddleU, dirtmiddleU, dirtrightUC, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, dirtleftUC, dirtmiddle, dirtmiddle, dirtmiddle, dirtright, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, dirtleftLC, dirtmiddleL, dirtmiddleL, dirtrightLC, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, 5, singleDirtBig, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, 5, 4, 5, 4, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, 5, 4, 5, 4, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4],
		        [4, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4,dirtleftUC, dirtrightUC,4, singleDirtSmall, 4,4, 4],
		        [4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, dirtleftLC, dirtmiddle, dirtright, 4, 4, 4, 4],
			[4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, dirtleft, dirtmiddle,  dirtrightUC, 4, 4, 4],
			[4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, dirtleftLC, dirtmiddle, dirtright, 4, 4, 4, 4],
			[4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,dirtleftLC, dirtmiddleL, dirtrightLC, 4, 4]
		    ]	
		);
		game.rootScene.addChild(map);
	}

	
	//GUI
	function createHeart()
	{
		var heart = new Sprite(16,16);
		heart.image = game.assets['icon0.png'];
		heart.frame = 10;
		return heart;
	}
	
	function setUpHeartDisplay()
	{
		for(i = 0; i < lives; ++i)
		{
			var h = createHeart();
			h.x = gamewidth + 16*(i+1);
			h.y = 32;
			game.rootScene.addChild(h);
			GUILives[i] = h;
		}

	}

	function removeHeart()
	{
		game.rootScene.removeChild(GUILives[GUILives.length-1]);
		GUILives.pop();
	}
	
	function displayDifficultyLevel()
	{
		var symbol = new Sprite(16,16);
		symbol.image = game.assets['icon0.png'];
		symbol.frame = 30;
		symbol.x = gamewidth + 16;
		symbol.y = gameheight/2;
	
		game.rootScene.addChild(symbol);
		
		var label = new Label("");
		label.text = "" + difficultLevel;
		label.x = gamewidth + 32 + 10;		
		label.y = gameheight/2 +2;
		GUIDifficultyLabel = label;
		
		game.rootScene.addChild(label);
	}

	function correctLabel()
	{
		GUIDifficultyLabel.text = "" + difficultLevel;
	}
	
	function displayGameOver()
	{
		var gameOver = new Sprite(189,97);
		gameOver.x = gamewidth/2 - 189/2;
		gameOver.y = gameheight/2 - 97/2;
		gameOver.image = game.assets['end.png'];
		game.rootScene.addChild(gameOver);
	}
	/*
	* Gamelogic
	*/

	function intializeGroups()
	{
		var group1 = createMoverGroup(5,7,groupSize);
		var group2 = createMoverGroup(0,2,groupSize);
		var group3 = createMoverGroup(10,12,groupSize);
		var group4 = createMoverGroup(15,17,groupSize);
		addGroup(group1);
		addGroup(group2);
		addGroup(group3);
		addGroup(group4);

	}

	game.onload = function(){
		setupBackGround();
		setUpHeartDisplay();
		intializeGroups();
		displayDifficultyLevel();
		//createSequence(sequenceLength);
		sequence = [0,2,3];
		createPartialSequence(sequenceLength); 
		shuffleMovementPattern();
		handleInput();
		game.rootScene.addEventListener("enterframe", function()
		{		
			handleMovement();
			handleSequences();
		});
	};
	/*
	* Gamelogic end
	*/
	game.start();
};
function rand(from, until)
{ 
	return Math.floor(Math.random() * (until-from+1) + from);
}
